// #include "PP/UtilityC.h"
#include <stdio.h>
#include <limits.h>
#include <stdbool.h>

void reverse(int *begin, int *end)
{
    for (int i = 0; i < (end-begin)/2; i++)
    {
        int temp = *(begin+i);
        *(begin+i) = *(end-1-i);
        *(end-1-i) = temp;
    }
}

void swap(int* x, int* y)
{
	int temp = *x;
	*x = *y;
	*y = temp;
}

int* selectionSort(int ori[], int n)
{
    // Copy to new ptr
	int *arr = (int*)malloc(sizeof(int)*n);
    for(int i=0; i<n; ++i)
      arr[i] = ori[i];

    
    // selection sort
	int index = -1;
	for(int begin = 0; begin < n; ++begin)
	{
		int min = INT_MAX;
		for (int i = begin; i < n; ++i)
		{
			if (arr[i] < min)
			{
				index = i;
				min = arr[i];
			}
		}
		if (index != -1)
			swap(&arr[index], &arr[begin]); // arr[i] is value
	}
    return arr;
}

void nextPermutation(int nums[], int n) {
    int k, l;
    for (k = n - 2; k >= 0; k--)
        if (nums[k] < nums[k + 1])
            break;

    if (k >= 0){
        for (l = n - 1; l > k; l--)
        {
            if (nums[l] > nums[k])
                break;
        } 
        swap(nums+k, nums+l);
        reverse(nums + k + 1, nums+n);
    }
    else{
        reverse(nums, nums+n);
    }
}


void printArray(int arr[], int n, bool hasEndLine)
{
    printf("{ ");
    for(int i=0; i<n; ++i)
        printf("%i ", arr[i]);
    printf("}");
    if(hasEndLine)
        printf("\n");
}

int main() 
{
    int nums[] = {0,1,2,3,4};

    int i = 0;
    while(i++<120)
    {
        printArray(nums,5,false);
        nextPermutation(nums, 5);
        int *res = selectionSort(nums,5);
        printf("  ");
        printArray(res,5,true);
    }
    return 0;
}


/*
 32 bit | 1111 1111 | 1111 1111 | 1111 1111 | 1111 1111 |
    Hex |   F    F      F    F      F    F      F    F  |
*/

